/**
 * TreeMap constants doc
 */
/**
 * Triggers when the treemap is on load.
 * @private
 */
export declare const load: string;
/**
 * Triggers after treemap rendered.
 * @private
 */
export declare const loaded: string;
/**
 * Trigger before call the print method.
 * @private
 */
export declare const beforePrint: string;
/**
 * Trigger before each treemap item rendered.
 * @private
 */
export declare const itemRendering: string;
/**
 * Trigger after click on treemap item.
 * @private
 */
export declare const drillStart: string;
/**
 * Trigger after drill start event completed.
 * @private
 */
export declare const drillEnd: string;
/**
 * Trigger after select the treemap item.
 * @private
 */
export declare const itemSelected: string;
/**
 * Trigger after hover on the treemap item.
 * @private
 */
export declare const itemHighlight: string;
/**
 * Trigger after mouse hover on the treemap item.
 * @private
 */
export declare const tooltipRendering: string;
/**
 * Trigger after click on the treemap item.
 * @private
 */
export declare const itemClick: string;
/**
 * Trigger after mouse hover on the treemap item.
 * @private
 */
export declare const itemMove: string;
/**
 * Trigger after click on the treemap item.
 * @private
 */
export declare const click: string;
/**
 * Trigger after double click on the treemap item.
 * @private
 */
export declare const doubleClick: string;
/**
 * Trigger after right click on the treemap item.
 * @private
 */
export declare const rightClick: string;
/**
 * Trigger after mouse hover on the treemap item.
 * @private
 */
export declare const mouseMove: string;
/**
 * Trigger before each treemap item.
 * @private
 */
export declare const legendItemRendering: string;
/**
 * Trigger before legend items.
 * @private
 */
export declare const legendRendering: string;
/**
 * Trigger after resize the treemap.
 * @private
 */
export declare const resize: string;
/**
 * Define the font family in treemap component.
 * @private
 */
export declare const defaultFont: string;
